#include <iostream>
#include <string>

using namespace std;

struct TBase
{
  virtual void print (void);
};

struct TInteger: public TBase
{
  int content;
  virtual void print (void);
  TInteger (int i);
};

struct TDoubleInteger: public TInteger
{
  int content2;
  virtual void print (void);
  TDoubleInteger (int i, int j);
};

struct TString: public TBase
{
  string content;
  virtual void print (void);
  TString (string s);
};

void TBase::print (void)
{
  cout << "Base" << endl;
}

void TInteger::print (void)
{
  cout << "Integer: " << content << endl;
}

TInteger::TInteger (int i)
{
  content = i;
}

void TDoubleInteger::print (void)
{
  cout << "DoubleInteger: " << content << ", " << content2 << endl;
}

TDoubleInteger::TDoubleInteger (int i, int j)
  : TInteger (i)
{
  content2 = j;
}

void TString::print (void)
{
  cout << "String: " << content << endl;
}

TString::TString (string s)
{
  content = s;
}

int main (void)
{
  TInteger i = 42;
  TDoubleInteger v (2, 3);
  TBase *object[] = { &i, &v, new TString ("Hello, world!"), NULL };

  for (int i = 0; object[i]; i++)
    object[i]->print ();

  return 0;
}
