#include <iostream>
#include <string>

using namespace std;

class TBase
{
public:
  virtual void print (void);
};

class TInteger: public TBase
{
private: // Ist bei "class" der Standard. Bei "struct": public.
  int content;
public:
  virtual void print (void);
  TInteger (int i);
};

class TDoubleInteger: public TInteger
{
  int content2;
public:
  virtual void print (void);
  TDoubleInteger (int i, int j);
};

class TString: public TBase
{
  private:
    string content;
  public:
    virtual void print (void);
    TString (string s);
    TString (char *s);
};

void TBase::print (void)
{
  cout << "Base" << endl;
}

void TInteger::print (void)
{
  cout << "Integer: " << content << endl;
}

TInteger::TInteger (int i)
{
  content = i;
}

void TDoubleInteger::print (void)
{
  cout << "DoubleInteger: " << content << ", " << content2 << endl;
}

TDoubleInteger::TDoubleInteger (int i, int j)
  : TInteger (i)
{
  content2 = j;
}

void TString::print (void)
{
  cout << "String: " << content << endl;
}

TString::TString (string s)
{
  content = s;
}

TString::TString (char *s)
{
  s[4] = 'a';
  content = s;
}

int main (void)
{
  TInteger i = 42;
  TDoubleInteger v (2, 3);
  string Hello = "Hello, world!";
  TString S = Hello;
  TBase *object[] = { &i, &v, &S, NULL };

  for (int i = 0; object[i]; i++)
    object[i]->print ();

  i.content = 137;
  S.content = "Tach auch.";

  for (int i = 0; object[i]; i++)
    object[i]->print ();

  return 0;
}
