#include <iostream>
#include <string>

using namespace std;

class TBase
{
  public:
    virtual void print (void)
    {
      cout << "Base" << endl;
    }
};

class TInteger: public TBase
{
  protected: // Bei "class" ist "private" der Standard, bei "struct" "public".
    int content;

  public:
    virtual void print (void)
    {
      cout << "Integer: " << content << endl;
    }

    TInteger (int i)
    {
      content = i;
    }

    void SetContent (int i)
    {
      content = i;
    }
};

class TDoubleInteger: public TInteger
{
  protected:
    int content2;
  public:
    virtual void print (void);
    TDoubleInteger (int i, int j);
};

class TString: public TBase
{
  protected:
    string content;
  public:
    virtual void print (void);
    TString (string s);
    TString (char *s);
    void SetContent (string s);
};

void TDoubleInteger::print (void)
{
  cout << "DoubleInteger: " << content << ", " << content2 << endl;
}

TDoubleInteger::TDoubleInteger (int i, int j)
  : TInteger (i)
{
  content2 = j;
}

void TString::print (void)
{
  cout << "String: " << content << endl;
}

TString::TString (string s)
{
  content = s;
}

TString::TString (char *s)
{
  s[4] = 'a';
  content = s;
}

void TString::SetContent (string s)
{
  content = s;
}

int main (void)
{
  TInteger i = 42;
  TDoubleInteger v (2, 3);
  string Hello = "Hello, world!";
  TString S = Hello;
  TBase *object[] = { &i, &v, &S, NULL };

  for (int i = 0; object[i]; i++)
    object[i]->print ();

  i.SetContent (137);
  S.SetContent ("Tach auch.");

  for (int i = 0; object[i]; i++)
    object[i]->print ();

  return 0;
}
