#include <stdio.h>
#include <stdlib.h>

union t_object;

typedef struct
{
  void (* print) (union t_object *this);
} t_base;

typedef struct
{
  void (* print) (union t_object *this);
  int content;
} t_integer;

typedef struct
{
  void (* print) (union t_object *this);
  char *content;
} t_string;

typedef union t_object
{
  t_base base;
  t_integer integer;
  t_string string;
} t_object;

void print_integer (t_object *this)
{
  printf ("Integer: %d\n", this->integer.content);
}

t_object *new_integer (int i)
{
  t_object *object = malloc (sizeof (t_integer));
  object->base.print = print_integer;
  object->integer.content = i;
  return object;
}

void print_string (t_object *this)
{
  printf ("String: %s\n", this->string.content);
}

t_object *new_string (char *s)
{
  t_object *object = malloc (sizeof (t_string));
  object->base.print = print_string;
  object->string.content = s;
  return object;
}

int main (void)
{
  t_object *object[] = { new_integer (42), new_string ("Hello, world!") };

  for (int i = 0; i < 2; i++)
    object[i]->base.print (object[i]);

  return 0;
}
